/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.View = Class.$define("APT.View");

APT.ActivityIndicatorView = Class.$define("APT.ActivityIndicatorView", APT.View, {
    __init__: function() {
        this._hidesWhenStopped = true;
        this._animating = false;
        this._style = APT.ActivityIndicatorViewStyle.WhiteLarge;
        this.$super();
    },

    $copy: function() {
        var copyObject = new APT.ActivityIndicatorView();
        copyObject._hidesWhenStopped = this._hidesWhenStopped;
        copyObject._animating = this._animating;
        copyObject._style = this._style;
        return copyObject;
    },

    getRenderMarkup: function() {
        return $(APT.Global.toStaticHTML("<div></div>"));
    },

    setJQElement: function(jqelement) {
        this._jqElement = $(".ui-loader");
        if (jqelement.attr("id") !== undefined)
        {
            this.jQElement().attr("id", jqelement.attr("id"));
            this.jQElement().attr("data-apt-class", jqelement.attr("data-apt-class"));

            this.setProperties();
        }
    },

    initWithActivityIndicatorStyle: function(aStyle) {
        this.setStyle(aStyle);
        return this;
    },

    startAnimating: function() {
        $(".ui-icon-loading").css("background-image", "url(lib/images/ajax-loader.gif)");
        $("html").addClass("ui-loading");
        this.jQElement().css("display", "block");
        this.jQElement().css("margin", 0);
        this._animating = true;
    },

    stopAnimating: function() {
        this._animating = false;
        if (this._hidesWhenStopped)
        {
            this.setHidden(true);
            $("html").removeClass("ui-loading");
            this.jQElement().css("display", "none");
        }
        else
        {
            this.setHidden(false);
            $(".ui-icon-loading").css("background-image", "url(lib/images/ajax-loader.png)");
        }
    },

    isAnimating: function() {
        return this._animating;
    },

    hidesWhenStopped: function() {
        return this._hidesWhenStopped;
    },

    setHidesWhenStopped: function(value) {
        this._hidesWhenStopped = value;
    },

    style: function() {
        return this._style;
    },

    setStyle: function(aStyle) {
        this._style = aStyle;
        var loader = $("span.ui-icon.ui-icon-loading");
        switch(aStyle)
        {
            case APT.ActivityIndicatorViewStyle.White:
                loader.css("width", 30);
                loader.css("height", 30);
                loader.css("background-size", "100%");
                break;
            case APT.ActivityIndicatorViewStyle.Gray:
                break;
            case APT.ActivityIndicatorViewStyle.WhiteLarge:
            default:
                loader.css("width", 46);
                loader.css("height", 46);
                loader.css("background-size", "100%");
                break;
        }
    },

});


