/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.MenuController = Class.$define("APT.MenuController", {
    __init__: function() {
        this._jqElement = null;
        this._menuItems = new Array();
        this._menuFrame = null;
        this._visible = true;
        this._cont = 0;
        this._view = null;
        if (this.jQElement() === null)
        {
            this.setJQElement(this.getRenderMarkup());
        }
    },

    $copy: function() {
        var copyObject = new APT.MenuController();
        copyObject._jqElement = this._jqElement;
        copyObject._menuItems = this._menuItems;
        copyObject._menuFrame = this._menuFrame.$copy();
        copyObject._visible = this._visible;
        copyObject._cont = this._cont;
        copyObject._view = this._view;
        return copyObject;
    },

    getRenderMarkup: function() {
        return $("<div data-role=\"popup\" data-overlay-theme=\"a\" style=\"background:black;\"><ul data-role=\"listview\" data-inset=\"true\" style=\"width:150px;display:-webkit-inline-box\" data-theme=\"c\"></ul></div>");
    },

    setJQElement: function(jqelement) {
        this._jqElement = jqelement.trigger("create");
    },

    jQElement: function() {
        return this._jqElement;
    },

    setMenuItems: function(aMenuItems) {
        if (aMenuItems !== null && aMenuItems !== undefined)
        {
            this._menuItems = aMenuItems;
            var contentUl = this.jQElement().children(1);
            var controller = this;

            var obj = this.jQElement().find("li");
            var array = obj;
            for (var i = 0; i < array.length; i++)
            {
                (array[i]).detach();
            }

            aMenuItems.forEach( function(menuItem)
            {
                var item = menuItem;
                contentUl.append(item.jQElement());
                item._controllerItem = controller;
            });
        }
        else
        {
            this._menuItems = null;
        }
    },

    menuItems: function() {
        return this._menuItems;
    },

    menuVisible: function() {
        return this._visible;
    },

    setMenuVisible_animated: function(visible, animated) {
        this._visible = visible;
    },

    setTargetRect_inView: function(targetRect, targetView) {
        targetRect = targetRect.$copy();
        this._menuFrame = targetRect.$copy();
    },

    menuFrame: function() {
        return this._menuFrame;
    },

    clickEvent: function(aView) {
        var aux = aView;
        var $that = this;

        aView.jQElement().on("vmouseup" + " _menuClick", function(event) {
            if (APT.MenuController.sharedMenuController()._visible !== false)
            {
                if (APT.MenuController.sharedMenuController()._cont > 0 && APT.MenuController.sharedMenuController()._menuItems.length > 0)
                {
                    (APT.MenuController.sharedMenuController())._view = aux.superview();
                    jQuery(APT.MenuController.sharedMenuController().jQElement()).popup();
                    var parameters = new Array();
                    if ($that._menuFrame === null)
                    {
                        if (event.originalEvent !== undefined)
                        {
                            parameters["x"] = event.originalEvent.pageX;
                            parameters["y"] = event.originalEvent.pageY;
                        }
                        else
                        {
                            parameters["x"] = 0;
                            parameters["y"] = 0;
                        }
                    }
                    else
                    {
                        parameters["x"] = $that._menuFrame.origin.x;
                        parameters["y"] = $that._menuFrame.origin.y;
                    }

                    jQuery(APT.MenuController.sharedMenuController().jQElement()).popup("open", parameters);
                    APT.MenuController.sharedMenuController()._cont = 0;
                }
                else
                {
                    APT.MenuController.sharedMenuController()._cont++;
                }
            }
        });
    },

});

APT.MenuController._menuController = null;

APT.MenuController.sharedMenuController = function() {
    if (APT.MenuController._menuController === null)
    {
        APT.MenuController._menuController = new APT.MenuController();
        $("#main-page").append(APT.MenuController._menuController.jQElement());
    }

    return APT.MenuController._menuController;
};


