/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.MenuItem = Class.$define("APT.MenuItem", {
    __init__: function() {
        this._jqElement = null;
        this._title = "";
        this._action = "";
        this.btnItemMenu = null;
        this._controllerItem = null;
        if (this.jQElement() === null)
        {
            this.setJQElement(this.getRenderMarkup());
        }
    },

    $copy: function() {
        var copyObject = new APT.MenuItem();
        copyObject._jqElement = this._jqElement;
        copyObject._title = this._title;
        copyObject._action = this._action;
        copyObject.btnItemMenu = this.btnItemMenu;
        copyObject._controllerItem = this._controllerItem;
        return copyObject;
    },

    getRenderMarkup: function() {
        return $("<li><a data-rel=\"popup\" data-role=\"button\" ></a></li>");
    },

    setJQElement: function(jqelement) {
        this._jqElement = jqelement.trigger("create");
    },

    jQElement: function() {
        return this._jqElement;
    },

    initWithTitle_action: function(aTitle, selector) {
        this.setTitle(aTitle);
        this.setAction(selector);

        this.btnItemMenu = APT.Button.buttonWithType(APT.ButtonType.RoundedRect);
        this.btnItemMenu.setTitle(this._title);
        this.btnItemMenu.setTitleColor(APT.Color.White);
        this.btnItemMenu.setBackgroundColor(APT.Color.Black);
        this.btnItemMenu.addTarget_action_forControlEvents(this, "actionClick", APT.ControlEvent.vmouseup);
        var buttonDiv = this.jQElement().find("a");
        buttonDiv.append(this.btnItemMenu.jQElement());
        this.jQElement().append(buttonDiv);

        return this;
    },

    setTitle: function(aTitle) {
        if (aTitle !== null && aTitle !== undefined)
        {
            this._title = aTitle;
            if (this.btnItemMenu !== null)
            {
                this.btnItemMenu.setTitle(aTitle);
            }
        }
        else
        {
            this._title = null;
        }
    },

    title: function() {
        return this._title;
    },

    setAction: function(aAction) {
        if (aAction !== null && aAction !== undefined)
        {
            this._action = aAction;
        }
        else
        {
            this._action = null;
        }
    },

    action: function() {
        return this._action;
    },

    actionClick: function() {
        var menu = APT.MenuController.sharedMenuController();
        if (menu._view !== null && menu._view.viewController()[this._action] instanceof Function)
        {
            (menu._view.viewController()[this._action.valueOf()])(menu._view);
        }

        $(APT.MenuController.sharedMenuController().jQElement()).popup("close");
    },

});


