/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.ViewController = Class.$define("APT.ViewController");
APT.TableViewController = Class.$define("APT.TableViewController", APT.ViewController);

APT.MoreListController = Class.$define("APT.MoreListController", APT.TableViewController, {
    __init__: function() {
        this._viewControllers = null;
        this._visibleViewControllers = new Array();
        this._numberOfViewControllersInTabBar = 4;
        this.$super();
        this.setTitle("More");
    },

    $copy: function() {
        var copyObject = new APT.MoreListController();
        copyObject._viewControllers = this._viewControllers;
        copyObject._visibleViewControllers = this._visibleViewControllers;
        copyObject._numberOfViewControllersInTabBar = this._numberOfViewControllersInTabBar;
        return copyObject;
    },

    setViewControllers: function(viewControllers) {
        this._viewControllers = viewControllers;
        if (this.areVisibleViewControllers())
        {
            this._visibleViewControllers = this._viewControllers.slice(this._numberOfViewControllersInTabBar);
        }
    },

    viewControllers: function() {
        return this._viewControllers;
    },

    setNumberOfViewControllersInTabBar: function(numberOfViewControllersInTabBar) {
        this._numberOfViewControllersInTabBar = numberOfViewControllersInTabBar;
    },

    numberOfViewControllersInTabBar: function() {
        return this._numberOfViewControllersInTabBar;
    },

    numberOfSectionsInTableView: function(aTableView) {
        return 1;
    },

    tableView_numberOfRowsInSection: function(aTableView, section) {
        return this._visibleViewControllers.length;
    },

    tableView_cellForRowAtIndexPath: function(aTableView, aIndexPath) {
        var cell = new APT.TableViewCell().initWithStyle(APT.TableViewCellStyle.Default);
        var viewController = this._visibleViewControllers[aIndexPath.row()];
        cell.textLabel().setText(viewController.tabBarItem().title());
        cell.imageView().setImage(viewController.tabBarItem().image());
        cell.setAccessoryType(APT.TableViewCellAccessoryType.DisclosureIndicator);
        return cell;
    },

    tableView_didSelectRowAtIndexPath: function(aTableView, aIndexPath) {
        var viewController = this._visibleViewControllers[aIndexPath.row()];
        this.navigationController().pushViewController_animated(viewController, true);
    },

    areVisibleViewControllers: function() {
        return this._viewControllers !== null && this._viewControllers !== undefined && this._viewControllers.length - this._numberOfViewControllersInTabBar > 0;
    },

});


