/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.BarItem = Class.$define("APT.BarItem");

APT.TabBarItem = Class.$define("APT.TabBarItem", APT.BarItem, {
    __init__: function() {
        this._tabBarButton = new APT.TabBarButtonDefault();
        this.$super();
    },

    $copy: function() {
        var copyObject = new APT.TabBarItem();
        copyObject._tabBarButton = this._tabBarButton;
        return copyObject;
    },

    initWithTitle_image_tag: function(title, image, tag) {
        this._tabBarButton.initWithTitle_image_tag(title, image, tag);
        return this;
    },

    initWithTabBarSystemItem_tag: function(systemItem, tag) {
        this._tabBarButton.initWithTabBarSystemItem_tag(systemItem, tag);
        return this;
    },

    setTitle: function(aTitle) {
        this._tabBarButton.setTitle(aTitle);
    },

    title: function() {
        return this._tabBarButton.title();
    },

    setImage: function(aImage) {
        this._tabBarButton.setImage(aImage);
    },

    image: function() {
        return this._tabBarButton.image();
    },

    setEnabled: function(enabled) {
        this._tabBarButton.setEnabled(enabled);
    },

    isEnabled: function() {
        return this._tabBarButton.isEnabled();
    },

    setTag: function(tag) {
        this._tabBarButton.setTag(tag);
    },

    tag: function() {
        return this._tabBarButton.tag();
    },

    defaultView: function() {
        return this._tabBarButton;
    },

    isSelected: function() {
        return this.defaultView().jQElement().find("a").hasClass("ui-btn-active");
    },

    setSelected: function(selected) {
        if (selected)
        {
            this.defaultView().jQElement().find("a").addClass("ui-btn-active");
        }
        else
        {
            this.defaultView().jQElement().find("a").removeClass("ui-btn-active");
        }
    },

    setTabBarButton: function(tabBarButton) {
        this._tabBarButton = tabBarButton;
    },

});


