/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.ViewController = Class.$define("APT.ViewController");

APT.TableViewController = Class.$define("APT.TableViewController", APT.ViewController, {
    __init__: function() {
        this._tableView = null;
        this.$super();
    },

    $copy: function() {
        var copyObject = new APT.TableViewController();
        copyObject._tableView = this._tableView;
        return copyObject;
    },

    tableView: function() {
        if (this._view === null)
        {
            this.view();
        }

        return this._tableView;
    },

    setTableView: function(newTableView) {
        this._tableView = newTableView;
        this._view = this._tableView;
        this._tableView.setViewController(this);
    },

    initWithStyle: function(aStyle) {
        var aFrame = APT.Rect.New(0, 0, 320, 480);
        (this.view()).initWithFrame_style(aFrame, aStyle);
        return this;
    },

    numberOfSectionsInTableView: function(aTableView) {
        return 1;
    },

    tableView_numberOfRowsInSection: function(aTableView, section) {
        return 0;
    },

    tableView_cellForRowAtIndexPath: function(aTableView, aIndexPath) {
        return null;
    },

    tableView_titleForHeaderInSection: function(aTableView, section) {
        return null;
    },

    tableView_didDeselectRowAtIndexPath: function(aTableView, aIndexPath) {
    },

    tableView_didSelectRowAtIndexPath: function(aTableView, aIndexPath) {
    },

    tableView_heightForRowAtIndexPath: function(aTableView, aIndexPath) {
        return aTableView.rowHeight();
    },

    tableView_heightForHeaderInSection: function(aTableView, aSection) {
        return aTableView.sectionHeaderHeight();
    },

    loadView: function() {
        this.setView(new APT.TableView());
        this._tableView.setDelegate(this);
        this._tableView.setDataSource(this);
    },

    setView: function(aView) {
        this._view = aView;
        this._view.setViewController(this);
        if (this._view instanceof APT.TableView)
        {
            this._tableView = this._view;
        }
        else
        {
            this._tableView = null;
        }
    },

});


