/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.Timer = Class.$define("APT.Timer", {
    __init__: function() {
        this._userInfo = null;
        this._handler = null;
        this._isInterval = false;
    },

    $copy: function() {
        var copyObject = new APT.Timer();
        copyObject._userInfo = this._userInfo;
        copyObject._handler = this._handler;
        copyObject._isInterval = this._isInterval;
        return copyObject;
    },

    userInfo: function() {
        return this._userInfo;
    },

    handler: function() {
        return this._handler;
    },

    setInterval: function(anInterval, anObject, aCallback) {
        this._isInterval = true;

        this._handler = window.setInterval(function() {
            anObject[aCallback.valueOf()].apply(anObject);
        }, anInterval);

        return this._handler;
    },

    setTimeout: function(anInterval, anObject, aCallback) {
        this._isInterval = false;

        this._handler = window.setTimeout(function() {
            anObject[aCallback.valueOf()].apply(anObject);
        }, anInterval);

        return this._handler;
    },

    clear: function() {
        if (this._isInterval)
        {
            window.clearInterval(this._handler);
        }
        else
        {
            window.clearTimeout(this._handler);
        }
    },

});

APT.Timer.Create = function(anInterval, anObject, aCallback, aUserInfo, repeats) {
    var timer = new APT.Timer();
    timer._userInfo = aUserInfo;

    if (repeats)
    {
        timer.setInterval(anInterval, anObject, aCallback);
    }
    else
    {
        timer.setTimeout(anInterval, anObject, aCallback);
    }

    return timer;
};


