/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.View = Class.$define("APT.View");

APT.ToolBar = Class.$define("APT.ToolBar", APT.View, {
    __init__: function() {
        this._items = null;
        this.$super();
    },

    $copy: function() {
        var copyObject = new APT.ToolBar();
        copyObject._items = this._items;
        return copyObject;
    },

    getRenderMarkup: function() {
        return $(APT.Global.toStaticHTML("<div data-role='controlgroup' data-type='horizontal' class='apt_navbar ui-header ui-bar-b'></div>"));
    },

    setJQElement: function(jqelement) {
        this._jqElement = jqelement.controlgroup();
        this._jqElement.css("margin", "0px");
    },

    barStyle: function() {
        if (this._jqElement.hasClass("ui-bar-b"))
        {
            return APT.BarStyle.Default;
        }
        else
        {
            return APT.BarStyle.Black;
        }
    },

    setBarStyle: function(value) {
        if (value === APT.BarStyle.Default)
        {
            this._jqElement.removeClass("ui-bar-a");
            this._jqElement.addClass("ui-bar-b");
        }
        else
        {
            this._jqElement.removeClass("ui-bar-b");
            this._jqElement.addClass("ui-bar-a");
        }
    },

    items: function() {
        return this._items;
    },

    setItems_animated: function(anArray, animated) {
        var item = null;
        this._items = anArray;
        this.jQElement().children().detach();

        if (this._items !== null && this._items !== undefined)
        {
            for (var i = 0; i < this._items.length; i++)
            {
                item = this._items[i];
                var itemView = item.defaultView();
                itemView.jQElement().css("margin", "5px");
                this.addSubview(itemView);
            }
        }
    },

    setItems: function(anArray) {
        this.setItems_animated(anArray, false);
    },

    processNode: function(markup, element) {
        var aux = element.children().clone();

        var items = new Array();
        APT.Global.processElement(aux, items);

        this.setJQElement(markup);
        this.setItems(items);
    },

    setUserInteractionEnabled: function(enabled) {
        for (var i = 0; i < this._items.length; i++)
        {
            (this._items[i]).defaultView().jQElement().prop("disabled", !enabled);
        }
    },

    isUserInteractionEnabled: function() {
        if (this._items.length > 0)
        {
            return !(this._items[0]).defaultView().jQElement().prop("disabled");
        }

        return true;
    },

});


