/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.View = Class.$define("APT.View");

APT.Window = Class.$define("APT.Window", APT.View, {
    __init__: function() {
        this._rootViewController = null;
        this._keyWindow = false;
        this._hidden = true;
        this.$super();
    },

    $copy: function() {
        var copyObject = new APT.Window();
        copyObject._rootViewController = this._rootViewController;
        copyObject._keyWindow = this._keyWindow;
        copyObject._hidden = this._hidden;
        return copyObject;
    },

    getRenderMarkup: function() {
        return $(APT.Global.toStaticHTML("<div class=\"apt_view apt_window\" data-viewtype=\"Window\"></div>"));
    },

    setJQElement: function(jqelement) {
        this._jqElement = jqelement.trigger("create");
        this._hidden = true;
        this._jqElement.css("visibility", "hidden");

        this.setProperties();
    },

    makeKeyAndVisible: function() {
        var obj = $(".apt_window");
        var array = obj;
        for (var i = 0; i < array.length; i++)
        {
            $(array[i]).css("visibility", "hidden");
        }

        this._keyWindow = true;
        this._hidden = false;
        this._jqElement.css("visibility", "visible");
        var value = parseFloat(1.0);
        this.setAlpha(value);
        if (this !== APT.Window._winActive)
        {
            this.keyWindow(this);
        }

        this.setFrame(APT.Screen.MainScreen().bounds());
        if (this._rootViewController !== null && this._rootViewController !== undefined)
        {
            this._rootViewController.view().setFrame(APT.Screen.MainScreen().bounds());
        }

        this.viewWillAppear(false);
        this.callSetNeedsDisplay(false);
        $("#main-page").append(this.jQElement());
        this.viewDidAppear(false);
    },

    makeKeyWindow: function() {
        this._keyWindow = true;
        if (this._hidden)
        {
            this._jqElement.css("visibility", "visible");
            this._hidden = false;
            var value = parseFloat(0.0);
            this.setAlpha(value);
        }

        if (this !== APT.Window._winActive)
        {
            this.keyWindow(this);
        }

        $("#main-page").append(this.jQElement());
    },

    keyWindow: function(win) {
        APT.Window._winActive = win;
    },

    setRootViewController: function(viewController) {
        this._rootViewController = viewController;
        if (viewController !== null && viewController !== undefined)
        {
            if (this.subviews().indexOf(viewController.view()) === APT.Global.NotFound)
            {
                this.addSubview(viewController.view());
            }
        }
    },

    rootViewController: function() {
        return this._rootViewController;
    },

    isKeyWindow: function() {
        if (this === APT.Window._winActive)
        {
            return true;
        }
        else
        {
            return false;
        }
    },

    insertSubviewAtIndex: function(aView, anIndex) {
        var len = this._subviews.length;
        if (aView !== null && aView !== this && anIndex >= 0 && anIndex <= len)
        {
            aView.willMoveToWindow(this);
            aView.setWindow(this);
            aView.willMoveToSuperview(this);

            if (aView.superview() !== null)
            {
                aView.removeFromSuperview();
            }

            var notifyFlag = this.isInDom() && !aView.isInDom();

            if (notifyFlag)
            {
                aView.viewWillAppear(false);
            }

            if (anIndex === len)
            {
                this._jqElement.append(aView.jQElement());
                this._subviews.push(aView);
            }
            else
            {
                aView.jQElement().insertBefore((this._subviews[anIndex]).jQElement());
                this._subviews.splice(anIndex, 0, aView);
            }

            if (notifyFlag)
            {
                aView.viewDidAppear(false);
            }

            aView._superview = this;

            aView.didMoveToWindow();
            aView.didMoveToSuperview();
            this.didAddSubview(aView);

            aView.setNeedsLayout();
        }
    },

    setFrame: function(aFrame) {
        aFrame = aFrame.$copy();
        this.$super(aFrame);
        this.jQElement().css("position", "fixed");
    },

});

APT.Window._winActive = null;

APT.Window.context = null;

APT.Window.currentGraphicsContext = function() {
    return APT.Window.context;
};

APT.Window.setCurrentGraphicsContext = function(aContect) {
    APT.Window.context = aContect;
};

APT.Window.popCurrentGraphicsContext = function() {
    APT.Window.context = null;
};


